/* A lit sphere   */
#include <GL/glut.h>

static int spin = 0;

    GLfloat no_mat[] = {0.0,0.0,0.0,1.0};
    GLfloat mat_ambient[] = {0.7,0.7,0.7,1.0};
    GLfloat mat_specular[] = {1.0,1.0,1.0,1.0};
    GLfloat mat_diffuse[] = {0.0,0.0,1.0,1.0};
    GLfloat no_shininess[] = {00.0};
    GLfloat low_shininess[] = {5.0};
    GLfloat high_shininess[] = {100.0};
    GLfloat mat_emission[] = {0.5,0.2,0.3,0.0};

void init(void)
{
    GLfloat light0_diffuse[] = {1.0,1.0,1.0,1.0};
    GLfloat light_position[] = {1.0,1.0,1.0,0.0};
    glLightfv (GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
    glLightfv (GL_LIGHT0, GL_POSITION, light_position);
        
    glEnable (GL_LIGHTING);
    glEnable (GL_LIGHT0);
}
    
void display (void)
{ 
    glClearColor (0.0, 0.2, 0.1, 0.0);
    glShadeModel (GL_SMOOTH);    
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glColor3f (1.0, 1.0, 1.0);
    
    glPushMatrix ();
    glTranslatef (-3.0, 0.0,0.0);
    glMaterialfv (GL_FRONT, GL_AMBIENT, no_mat);
    glMaterialfv (GL_FRONT, GL_DIFFUSE, mat_diffuse);
    glMaterialfv (GL_FRONT, GL_SPECULAR, no_mat);
    glMaterialfv (GL_FRONT, GL_SHININESS, no_shininess); 
    glMaterialfv (GL_FRONT, GL_EMISSION, no_mat);
    glRotated ((GLdouble) spin, 0.0, 1.0, 0.0);    
    glutSolidSphere (1.0, 200, 200);
    glPopMatrix ();

    glPushMatrix ();
    glTranslatef (0.0, 0.0,0.0);
    glMaterialfv (GL_FRONT, GL_AMBIENT, no_mat);
    glMaterialfv (GL_FRONT, GL_DIFFUSE, mat_diffuse);
    glMaterialfv (GL_FRONT, GL_SPECULAR, mat_specular);
    glMaterialfv (GL_FRONT, GL_SHININESS, high_shininess); 
    glMaterialfv (GL_FRONT, GL_EMISSION, no_mat);
    glRotated ((GLdouble) spin, 0.0, 1.0, 0.0);    
    glutSolidSphere (1.0, 200, 200);
    glPopMatrix ();
    
    glPushMatrix ();
    glTranslatef (3.0, 0.0,0.0);
    glMaterialfv (GL_FRONT, GL_AMBIENT, no_mat);
    glMaterialfv (GL_FRONT, GL_DIFFUSE, mat_diffuse);
    glMaterialfv (GL_FRONT, GL_SPECULAR, no_mat);
    glMaterialfv (GL_FRONT, GL_SHININESS, no_shininess); 
    glMaterialfv (GL_FRONT, GL_EMISSION, mat_emission);
    glRotated ((GLdouble) spin, 0.0, 1.0, 0.0);    
    glutSolidSphere (1.0, 200, 200);
    glPopMatrix ();
    
    glutSwapBuffers ();
}

void reshape(int w, int h)
{
    glViewport (0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    gluPerspective (60.0, (GLfloat) w/(GLfloat) h, 1.0, 20.0);
    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();
    gluLookAt (0.0,0.0,8.0, 0.0,0.0,0.0, 0.0,1.0,0.0);
}

void keyboard (unsigned char key, int x, int y)
{
    switch (key) {
        case 'd':
            spin = (spin + 180) % 360;
            glutPostRedisplay ();
            break;
        default:
            break;
    }
}

int main(int argc, char** argv)
{
    glutInit (&argc, argv);
    glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
    glutInitWindowSize (500, 500);
    glutInitWindowPosition (100, 100);
    glutCreateWindow ("A lit sphere");
    init ();
    glutDisplayFunc (display);
    glutReshapeFunc (reshape);
    glutKeyboardFunc (keyboard);
    glutMainLoop();
    return 0;
}
