// Aliased (red) and Antialiased (green) Lines

#include <GL/glut.h>
#include <stdlib.h>

static GLfloat spin = 0.0;

void init(void)
{
    glEnable (GL_LINE_SMOOTH);
    glEnable (GL_BLEND);
    glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glClearColor (0.0, 0.0, 0.0, 0.0);
}
    
void display (void)
{ 
    glClear (GL_COLOR_BUFFER_BIT);
    glColor3f(1.0,0.0,0.0);
	glLineWidth(4);
    glPushMatrix();
    glRotatef(spin,0.0,0.0,1.0);
    glBegin(GL_LINES);
        glVertex2f(-0.5,0.5);
        glVertex2f(0.5,-0.5);
    glEnd();
    glPopMatrix();
    
    glColor3f(0.0,1.0,0.0);
    glDisable(GL_LINE_SMOOTH);
    glPushMatrix();
    glRotatef(-spin,0.0,0.0,1.0);
    glBegin(GL_LINES);
        glVertex2f(0.5,0.5);
        glVertex2f(-0.5,-0.5);
    glEnd();
    glEnable(GL_LINE_SMOOTH);
    glPopMatrix();
    
    glFlush();
}

void keyboard (unsigned char key, int x, int y)
{
    switch (key) {
        case 'r':
            spin += 0.25; 
            if (spin > 360.0) spin = 0.0;
            glutPostRedisplay();
            break;
        default:
            break;
    }
}

int main(int argc, char** argv)
{
    glutInit (&argc, argv);
    glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
    glutInitWindowSize (1000, 1000);
    glutInitWindowPosition (100, 100);
    glutCreateWindow ("Aliased and Antialiased Lines");
    init ();
    glutDisplayFunc (display);
    glutKeyboardFunc (keyboard);
    glutMainLoop();
    return 0;
}
