// Drawing Pixel Data of Image

#include <GL/glut.h>

#define checkImageWidth 256
#define checkImageHeight 256

GLubyte checkImage[checkImageHeight][checkImageWidth][3];

void makeCheckImage(void)
{
    int i,j,c;
    
    for (i = 0; i < checkImageHeight; i++) {
        for (j = 0; j < checkImageWidth; j++) {
            c = ((((i&0x8)==0)^((j&0x8))==0))*255;
            checkImage[i][j][0] = (GLubyte) c;
            checkImage[i][j][1] = (GLubyte) c;
            checkImage[i][j][2] = (GLubyte) c;
        }
    }

}

void init(void)
{
    glClearColor (1.0, 1.0, 1.0, 1.0);
    glShadeModel (GL_FLAT);  
    makeCheckImage();
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
}
    
void display (void)
{ 
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glRasterPos2i(0,0);
    glDrawPixels(checkImageWidth, checkImageHeight, GL_RGB, GL_UNSIGNED_BYTE, checkImage);
    glFlush();
}

void reshape(int w, int h)
{
    glViewport (0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    gluPerspective (60.0, (GLfloat) w/(GLfloat) h, 1.0, 20.0);
    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();
    gluLookAt (1.0,1.0,1.0, 0.0,0.0,0.0, 0.0,1.0,0.0);
}

int main(int argc, char** argv)
{
    glutInit (&argc, argv);
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
    glutInitWindowSize (1000, 1000);
    glutInitWindowPosition (100, 100);
    glutCreateWindow ("Drawing Pixel Data of Image");
    init ();
    glutDisplayFunc (display);
    glutReshapeFunc (reshape);
    glutMainLoop();
    return 0;
}
