/* Display list   */
#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>

GLuint triangle;


static void init(void)		/* Create display list with triangle and initialize state */
{
    triangle = glGenLists (1);
    glNewList (triangle, GL_COMPILE);
        glPushAttrib(GL_CURRENT_BIT);        /*  To store the current red color after this */
        glColor3f(1.0,0.0,0.0);		     /* display list is executed */
        glBegin(GL_TRIANGLES);
            glVertex2f(0.0, 0.0);
            glVertex2f(1.0, 0.0);
            glVertex2f(0.0, 1.0);
        glEnd();
        glTranslatef(1.5, 0.0, 0.0);
        glPopAttrib();
    glEndList();
}

static void drawLine (void)
{
    glBegin(GL_LINES);
        glVertex2f (0.0, 0.0);
        glVertex2f (0.0, 5.0);
    glEnd();
}

void display (void)
{ 
    GLuint i;
    
    glClearColor (1.0,1.0,1.0,0.0);    
    glClear (GL_COLOR_BUFFER_BIT);
    glColor3f (0.0, 1.0, 0.0);
    for (i = 0; i < 3; i++)
        glCallList (triangle);
    drawLine ();
    glFlush ();
}

void reshape(int w, int h)
{
    glViewport (0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    gluPerspective (30.0, (GLfloat) w/(GLfloat) h, 1.0, 100.0);
    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();
    gluLookAt(0.0,0.0,20.0, 0.0,0.0,0.0, 0.0,1.0,0.0);
}

int main(int argc, char** argv)
{
    glutInit (&argc, argv);
    glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
    glutInitWindowSize (1000, 1000);
    glutInitWindowPosition (100, 100);
    glutCreateWindow ("Rotating Torus");
    init ();
    glutDisplayFunc (display);
    glutReshapeFunc (reshape);
    glutMainLoop();
    return 0;
}