#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>

GLfloat ctrlpoints[4][4][3] = {
{{-1.5,-1.5, 4.0},{-0.5,-1.5,2.0},{ 0.5,-1.5,-1.0},{ 1.5,-1.5, 2.0}},
{{-1.5,-0.5, 1.0},{-0.5,-0.5, 3.0},{ 0.5,-0.5, 0.0},{ 1.5,-0.5,-1.0}},
{{-1.5, 0.5, 4.0},{-0.5, 0.5, 0.0},{ 0.5, 0.5, 3.0},{ 1.5, 0.5, 4.0}},
{{-1.5, 1.5,-2.0},{-0.5, 1.5,-2.0},{ 0.5, 1.5, 0.0},{ 1.5, 1.5,-1.0}}
};
    
void init(void)
{
    GLfloat mat_specular[] = {1.0,1.0,1.0,1.0};
    GLfloat mat_shininess[] = {100.0};
    GLfloat light0_diffuse[] = {1.0,0.0,0.0,1.0};
    GLfloat light0_position[] = {1.0,1.0,1.0,0.0};
    
    glClearColor (0.1, 0.1, 0.2, 0.0);
    glShadeModel (GL_SMOOTH);    
    
    glMaterialfv (GL_FRONT, GL_SPECULAR, mat_specular);
    glMaterialfv (GL_FRONT, GL_SHININESS, mat_shininess);
    glLightfv (GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
    glLightfv (GL_LIGHT0, GL_POSITION, light0_position);
    
    glEnable (GL_LIGHTING);
    glEnable (GL_LIGHT0);
    glEnable (GL_DEPTH_TEST);

    glMap2f(GL_MAP2_VERTEX_3, 0, 1, 3, 4, 0, 1, 12, 4, &ctrlpoints[0][0][0]);
    glEnable(GL_MAP2_VERTEX_3);
    glEnable(GL_AUTO_NORMAL);
    glMapGrid2f(20, 0.0, 1.0, 20, 0.0, 1.0);
}

void display(void)
{
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glPushMatrix();
        glRotatef(85.0, 1.0, 1.0, 1.0);
        glEvalMesh2(GL_FILL, 0, 20, 0, 20);
    glPopMatrix();
    glFlush();
}

void reshape(int w, int h)
{
    glViewport (0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    if (w <= h)
        glOrtho (-5.0, 5.0, -5.0*(GLfloat)h/(GLfloat)w, 
        5.0*(GLfloat)h/(GLfloat)w, -5.0, 5.0);
    else
        glOrtho (-5.0*(GLfloat)w/(GLfloat)h, 
        5.0*(GLfloat)w/(GLfloat)h,-5.0,5.0, -5.0, 5.0);
    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();
}

void keyboard (unsigned char key, int x, int y)
{
    switch (key) {
        case 27:
            exit(0);
            break;
        default:
            break;
    }
}

int main(int argc, char** argv)
{
    glutInit (&argc, argv);
    glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
    glutInitWindowSize (1000, 1000);
    glutInitWindowPosition (100, 100);
    glutCreateWindow ("2D Evaluator");
    init ();
    glutDisplayFunc (display);
    glutReshapeFunc (reshape);
    glutKeyboardFunc (keyboard);
    glutMainLoop();
    return 0;
}
