#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>

int board[3][3];    /* amount of color for each square */
    
void init(void)	    /* clear color value for every square on board */
{
    int i, j;
    for (i = 0; i < 3; i++)
        for (j = 0; j < 3; j++)
            board[i][j] = 0;
    glClearColor(0.0,0.0,0.0,0.0);
}

void drawSquares(GLenum mode)       /* draw a 3x3 grid of squares; drawing occurs only when  */
{					/* mode is RENDER  */
    GLuint i, j;
    for (i = 0; i < 3; i++) {
        if (mode == GL_SELECT)
            glLoadName (i);
        for (j = 0; j < 3; j++) {
            if (mode == GL_SELECT)
                glPushName(j);
            glColor3f ((GLfloat)i/3.0, (GLfloat) j/3.0, (GLfloat) board[i][j]/3.0);
            glRecti (i,j,i+1,j+1);
            if (mode == GL_SELECT)
                glPopName();
        }
    }
}
 
void processHits (GLint hits, GLuint buffer[])     
{
    unsigned int i, j;
    GLuint ii, jj, names, *ptr;
    
    ptr = (GLuint *) buffer;
    for (i = 0; i < hits; i++) {
        names = *ptr;
        for (j = 0; j < 3; j++) {
            if (j == 0)
                ii = *ptr;
            else if (j == 1)
                jj = *ptr;
            ptr++;
        }
        board[ii][jj] = (board[ii][jj] + 1) % 3;
    }
}


# define BUFSIZE 512

void pickSquares (int button, int state, int x, int y)
{
    GLuint selectBuf[BUFSIZE];
    GLint hits;
    GLint viewport[4];
    
    if (button != GLUT_LEFT_BUTTON || state != GLUT_DOWN)
        return;
    
    glGetIntegerv (GL_VIEWPORT, viewport);
    
    glSelectBuffer (BUFSIZE, selectBuf);
    (void) glRenderMode (GL_SELECT);
    
    glInitNames();
    glPushName(0);
    
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    gluPickMatrix((GLdouble)x, (GLdouble) y, 40.0, 40.0, viewport);
    gluOrtho2D(0.0,3.0,0.0,3.0);
    drawSquares(GL_SELECT);
    
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glFlush();
    
    hits = glRenderMode(GL_RENDER);
    processHits (hits, selectBuf);
    glutPostRedisplay();
}


void display(void)
{
    glClear (GL_COLOR_BUFFER_BIT);
    drawSquares(GL_RENDER);
    glFlush();
}

void reshape(int w, int h)
{
    glViewport (0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    gluOrtho2D (0.0, 3.0, 0.0, 3.0);
    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();
}

int main(int argc, char** argv)
{
    glutInit (&argc, argv);
    glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
    glutInitWindowSize (1000, 1000);
    glutInitWindowPosition (100, 100);
    glutCreateWindow ("Selection Mode");
    init ();
    glutDisplayFunc (display);
    glutReshapeFunc (reshape);
    glutMouseFunc (pickSquares);
    glutMainLoop();
    return 0;
}
